# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.DataRetentionConfig do
  @moduledoc """
  The configuration setting for Airflow database data retention mechanism.

  ## Attributes

  *   `airflowMetadataRetentionConfig` (*type:* `GoogleApi.Composer.V1.Model.AirflowMetadataRetentionPolicyConfig.t`, *default:* `nil`) - Optional. The retention policy for airflow metadata database.
  *   `taskLogsRetentionConfig` (*type:* `GoogleApi.Composer.V1.Model.TaskLogsRetentionConfig.t`, *default:* `nil`) - Optional. The configuration settings for task logs retention
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :airflowMetadataRetentionConfig =>
            GoogleApi.Composer.V1.Model.AirflowMetadataRetentionPolicyConfig.t() | nil,
          :taskLogsRetentionConfig =>
            GoogleApi.Composer.V1.Model.TaskLogsRetentionConfig.t() | nil
        }

  field(:airflowMetadataRetentionConfig,
    as: GoogleApi.Composer.V1.Model.AirflowMetadataRetentionPolicyConfig
  )

  field(:taskLogsRetentionConfig, as: GoogleApi.Composer.V1.Model.TaskLogsRetentionConfig)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.DataRetentionConfig do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.DataRetentionConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.DataRetentionConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
