# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.ImageVersion do
  @moduledoc """
  ImageVersion information

  ## Attributes

  *   `creationDisabled` (*type:* `boolean()`, *default:* `nil`) - Whether it is impossible to create an environment with the image version.
  *   `imageVersionId` (*type:* `String.t`, *default:* `nil`) - The string identifier of the ImageVersion, in the form: "composer-x.y.z-airflow-a.b.c"
  *   `isDefault` (*type:* `boolean()`, *default:* `nil`) - Whether this is the default ImageVersion used by Composer during environment creation if no input ImageVersion is specified.
  *   `releaseDate` (*type:* `GoogleApi.Composer.V1.Model.Date.t`, *default:* `nil`) - The date of the version release.
  *   `supportedPythonVersions` (*type:* `list(String.t)`, *default:* `nil`) - supported python versions
  *   `upgradeDisabled` (*type:* `boolean()`, *default:* `nil`) - Whether it is impossible to upgrade an environment running with the image version.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :creationDisabled => boolean() | nil,
          :imageVersionId => String.t() | nil,
          :isDefault => boolean() | nil,
          :releaseDate => GoogleApi.Composer.V1.Model.Date.t() | nil,
          :supportedPythonVersions => list(String.t()) | nil,
          :upgradeDisabled => boolean() | nil
        }

  field(:creationDisabled)
  field(:imageVersionId)
  field(:isDefault)
  field(:releaseDate, as: GoogleApi.Composer.V1.Model.Date)
  field(:supportedPythonVersions, type: :list)
  field(:upgradeDisabled)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.ImageVersion do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.ImageVersion.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.ImageVersion do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
