# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.ListWorkloadsResponse do
  @moduledoc """
  Response to ListWorkloadsRequest.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The page token used to query for the next page if one exists.
  *   `workloads` (*type:* `list(GoogleApi.Composer.V1.Model.ComposerWorkload.t)`, *default:* `nil`) - The list of environment workloads.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :workloads => list(GoogleApi.Composer.V1.Model.ComposerWorkload.t()) | nil
        }

  field(:nextPageToken)
  field(:workloads, as: GoogleApi.Composer.V1.Model.ComposerWorkload, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.ListWorkloadsResponse do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.ListWorkloadsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.ListWorkloadsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
