# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.LoadSnapshotRequest do
  @moduledoc """
  Request to load a snapshot into a Cloud Composer environment.

  ## Attributes

  *   `skipAirflowOverridesSetting` (*type:* `boolean()`, *default:* `nil`) - Whether or not to skip setting Airflow overrides when loading the environment's state.
  *   `skipEnvironmentVariablesSetting` (*type:* `boolean()`, *default:* `nil`) - Whether or not to skip setting environment variables when loading the environment's state.
  *   `skipGcsDataCopying` (*type:* `boolean()`, *default:* `nil`) - Whether or not to skip copying Cloud Storage data when loading the environment's state.
  *   `skipPypiPackagesInstallation` (*type:* `boolean()`, *default:* `nil`) - Whether or not to skip installing Pypi packages when loading the environment's state.
  *   `snapshotPath` (*type:* `String.t`, *default:* `nil`) - A Cloud Storage path to a snapshot to load, e.g.: "gs://my-bucket/snapshots/project_location_environment_timestamp".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :skipAirflowOverridesSetting => boolean() | nil,
          :skipEnvironmentVariablesSetting => boolean() | nil,
          :skipGcsDataCopying => boolean() | nil,
          :skipPypiPackagesInstallation => boolean() | nil,
          :snapshotPath => String.t() | nil
        }

  field(:skipAirflowOverridesSetting)
  field(:skipEnvironmentVariablesSetting)
  field(:skipGcsDataCopying)
  field(:skipPypiPackagesInstallation)
  field(:snapshotPath)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.LoadSnapshotRequest do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.LoadSnapshotRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.LoadSnapshotRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
