# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.SaveSnapshotResponse do
  @moduledoc """
  Response to SaveSnapshotRequest.

  ## Attributes

  *   `snapshotPath` (*type:* `String.t`, *default:* `nil`) - The fully-resolved Cloud Storage path of the created snapshot, e.g.: "gs://my-bucket/snapshots/project_location_environment_timestamp". This field is populated only if the snapshot creation was successful.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :snapshotPath => String.t() | nil
        }

  field(:snapshotPath)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.SaveSnapshotResponse do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.SaveSnapshotResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.SaveSnapshotResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
