# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.StorageConfig do
  @moduledoc """
  The configuration for data storage in the environment.

  ## Attributes

  *   `bucket` (*type:* `String.t`, *default:* `nil`) - Optional. The name of the Cloud Storage bucket used by the environment. No `gs://` prefix.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :bucket => String.t() | nil
        }

  field(:bucket)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.StorageConfig do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.StorageConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.StorageConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
