# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1.Model.WebServerNetworkAccessControl do
  @moduledoc """
  Network-level access control policy for the Airflow web server.

  ## Attributes

  *   `allowedIpRanges` (*type:* `list(GoogleApi.Composer.V1.Model.AllowedIpRange.t)`, *default:* `nil`) - A collection of allowed IP ranges with descriptions.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :allowedIpRanges => list(GoogleApi.Composer.V1.Model.AllowedIpRange.t()) | nil
        }

  field(:allowedIpRanges, as: GoogleApi.Composer.V1.Model.AllowedIpRange, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1.Model.WebServerNetworkAccessControl do
  def decode(value, options) do
    GoogleApi.Composer.V1.Model.WebServerNetworkAccessControl.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1.Model.WebServerNetworkAccessControl do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
