# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1beta1.Model.AirflowMetadataRetentionPolicyConfig do
  @moduledoc """
  The policy for airflow metadata database retention.

  ## Attributes

  *   `retentionDays` (*type:* `integer()`, *default:* `nil`) - Optional. How many days data should be retained for.
  *   `retentionMode` (*type:* `String.t`, *default:* `nil`) - Optional. Retention can be either enabled or disabled.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :retentionDays => integer() | nil,
          :retentionMode => String.t() | nil
        }

  field(:retentionDays)
  field(:retentionMode)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1beta1.Model.AirflowMetadataRetentionPolicyConfig do
  def decode(value, options) do
    GoogleApi.Composer.V1beta1.Model.AirflowMetadataRetentionPolicyConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1beta1.Model.AirflowMetadataRetentionPolicyConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
