# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1beta1.Model.CidrBlock do
  @moduledoc """
  CIDR block with an optional name.

  ## Attributes

  *   `cidrBlock` (*type:* `String.t`, *default:* `nil`) - CIDR block that must be specified in CIDR notation.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - User-defined name that identifies the CIDR block.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cidrBlock => String.t() | nil,
          :displayName => String.t() | nil
        }

  field(:cidrBlock)
  field(:displayName)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1beta1.Model.CidrBlock do
  def decode(value, options) do
    GoogleApi.Composer.V1beta1.Model.CidrBlock.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1beta1.Model.CidrBlock do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
