# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1beta1.Model.ListImageVersionsResponse do
  @moduledoc """
  The ImageVersions in a project and location.

  ## Attributes

  *   `imageVersions` (*type:* `list(GoogleApi.Composer.V1beta1.Model.ImageVersion.t)`, *default:* `nil`) - The list of supported ImageVersions in a location.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The page token used to query for the next page if one exists.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :imageVersions => list(GoogleApi.Composer.V1beta1.Model.ImageVersion.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:imageVersions, as: GoogleApi.Composer.V1beta1.Model.ImageVersion, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1beta1.Model.ListImageVersionsResponse do
  def decode(value, options) do
    GoogleApi.Composer.V1beta1.Model.ListImageVersionsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1beta1.Model.ListImageVersionsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
