# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Composer.V1beta1.Model.PollAirflowCommandRequest do
  @moduledoc """
  Poll Airflow Command request.

  ## Attributes

  *   `executionId` (*type:* `String.t`, *default:* `nil`) - The unique ID of the command execution.
  *   `nextLineNumber` (*type:* `integer()`, *default:* `nil`) - Line number from which new logs should be fetched.
  *   `pod` (*type:* `String.t`, *default:* `nil`) - The name of the pod where the command is executed.
  *   `podNamespace` (*type:* `String.t`, *default:* `nil`) - The namespace of the pod where the command is executed.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :executionId => String.t() | nil,
          :nextLineNumber => integer() | nil,
          :pod => String.t() | nil,
          :podNamespace => String.t() | nil
        }

  field(:executionId)
  field(:nextLineNumber)
  field(:pod)
  field(:podNamespace)
end

defimpl Poison.Decoder, for: GoogleApi.Composer.V1beta1.Model.PollAirflowCommandRequest do
  def decode(value, options) do
    GoogleApi.Composer.V1beta1.Model.PollAirflowCommandRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Composer.V1beta1.Model.PollAirflowCommandRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
